<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\models\Key;

/**
 * KeySearch represents the model behind the search form about `common\models\Key`.
 */
class KeySearch extends Key
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            /*[['id_key', 'status', 'type'], 'integer'],
            [['number', 'created_at', 'updated_at'], 'safe'],*/
            [['number'], 'safe'],
            [['rfid_key'], 'safe']
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Key::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'id_key' => $this->id_key,
            'number' => $this->number,
            'rfid_key' => $this->rfid_key,
            'status' => $this->status,
            'type' => $this->type,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'number', $this->number]);

        return $dataProvider;
    }
}
